import { Button, Descriptions, Badge, Popconfirm, Row, Col, Form, Input, Select, Table } from 'antd';
import React from 'react';
import { initFilter, extendRule, extendInclude, showFiles, extendIgnoreDataRule, setDataFieldValue, showApprove, guid, initQueryFilter, ShowDateTime, ShowPrintClose } from '../../../utils/common';
import ReactToPrint from 'react-to-print';
import { ExportToExcel } from '@woowalker/feui'
import XLSX from 'xlsx';
import { connect } from 'dva';
import moment from 'moment';
import { message } from 'antd/lib/index';
import styles from '../HI/StepForm.css';
import config from '../../../config.js';
import FormPage from '../../FormPage'
class CM002ShowPrint extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            data: null,
            btndisplay: 'none',
            isCheck: false, //是否待办 审批
        }
    }

    componentDidMount() {
        if (this.props.data?.id)
            this.loadData(this.props.data?.id);
    }

    componentWillReceiveProps(NextProps) {
        if (NextProps.data?.id && this.props.data?.id != NextProps.data?.id) {
            this.loadData(NextProps.data?.id);
        }
    }

    onTableBtnExport() {
        let TableWrap = document.getElementById('table1');
        let Table = TableWrap.getElementsByTagName('table1')[0];
        const wb = XLSX.utils.table_to_book(Table);
        XLSX.writeFile(wb, this.props.record.Nav_Department.NAME + '.xlsx')

    }

    onClickApprove = (appVisible) => {
        const newtmpData = {
            data: { id: this.props.data.id, isShow: true, key: guid(), param: this.props.data.param, appVisible: appVisible, BtnAgreeDisplay: 'none' },
            formCode: 'PF123',
        }
        this.setState({
            tmpData: newtmpData,
        });
    }
    loadData = (id) => {
        var isCheck = (this.props.data.tableKey != undefined && this.props.data.tableKey == '1') ? true : false
        var orgId = this.props.login ? this.props.login.OrgId : '';
        let json = initFilter(orgId);
        extendRule(json, 'ID', 1, id);
        extendInclude(json, 'Nav_Department')
        extendInclude(json, 'Nav_listPlanDetail.Nav_Department')
        extendInclude(json, 'Nav_listPlanDetail.Nav_User')
        extendInclude(json, 'Nav_listPlanDetail.Nav_ListStandard.Nav_StandardCreate')
        extendIgnoreDataRule(json)
        this.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'CM/DrillPlan/Get',
            onComplete: (ret) => {
                if (ret) {
                    this.setState({
                        data: ret,
                        isCheck: false
                    })
                }
            }
        });
    }
    sign = () => {
        let json = initFilter(this.props.login.OrgId, this.props.data.id, null, null, null, this.props.data.TaskID);
        extendRule(json, 'ID', 1, this.props.data.id);
        extendRule(json, 'Parameter1', 1, this.props.data.TaskID)
        this.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'CM/CMEquipmentDemandSurvey/Sign',
            onComplete: (ret) => {
                ShowPrintClose(this.props)
            }
        });
    }
    render() {
        const { data, isCheck } = this.state;
        return <div>
            <div style={{ padding: '10px' }}>
                <table>
                    <tr>
                        <td><Button onClick={() => this.onClickApprove(true)} style={{ marginRight: '8px' }} icon='export'>审批详情</Button></td>
                        <td><ReactToPrint trigger={() => <Button type={'default'} icon={'printer'} >打印</Button>} content={() => this.componentRef} pageStyle={"#tableId" + this.props.data.id + " { padding:0 40px;} img{width :120px}"} /></td>
                        <td><ExportToExcel fileName='年度应急演练计划表' tableId={'tableId' + this.props.data.id} /></td>
                        {isCheck ? <td><Button type={'primary'} icon={'check'} onClick={() => this.sign()} >确认</Button>  </td> : null}
                    </tr>
                </table>
            </div>
            <FormPage {...this.state.tmpData} />
            <div ref={el => (this.componentRef = el)} style={{ padding: '20px', paddingTop: '20px' }} id={'tableId' + this.props.data.id}>
                <h1 className={styles.showPrintHead}>年度应急演练计划表</h1>
                {
                    data ? <div style={{ width: '95%' }}>
                        <Descriptions title='' size='middle' bordered>
                            <Descriptions.Item label="年度">{data.YEAR}</Descriptions.Item>
                            <Descriptions.Item label="制定部门">{data.Nav_Department.NAME}</Descriptions.Item>
                        </Descriptions>
                    </div> : null
                }
                {
                    (data?.Nav_listPlanDetail && data?.Nav_listPlanDetail.length > 0) ?
                        <table className={styles.PrintFormLight}>
                            <tbody>
                                {/* <tr>
                                    <td colSpan={6} className={styles.showPrintHead2}>应急演练计划明细</td>
                                </tr> */}
                                <tr className={styles.PrintFormLightTh}>
                                    <td>应急演练时间</td>
                                    <td>应急演练名称</td>
                                    <td>关联应急预案</td>
                                    <td>组织演练部门</td>
                                    <td>责任人</td>
                                    <td>演练方案触发时间</td>
                                </tr>
                                {data?.Nav_listPlanDetail?.map((item, i) => {
                                    return <tr>
                                        <td>{item.DRLL_DATE?.substring(0, 7)} </td>
                                        <td>{item.NAME} </td>
                                        <td>{
                                            item.Nav_ListStandard?.map((itmc, j) => {
                                                return (j > 0 ? "，" : "") + itmc.Nav_StandardCreate.NAME
                                            })
                                        } </td>
                                        <td>{item.Nav_Department?.NAME} </td>
                                        <td>{item.Nav_User?.NAME} </td>
                                        <td>{item.TRIGGER_TIME?.split(' ')[0]} </td>
                                    </tr>
                                })}
                            </tbody>
                        </table>
                        : null
                }
            </div>
        </div>
    }
}
export default connect(({ login }) => ({ login }))(CM002ShowPrint) 
